/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import * as runtime from '../runtime';
import type {
  HostSettings,
} from '../models';
import {
    HostSettingsFromJSON,
    HostSettingsToJSON,
} from '../models';

export interface AddHostSettingsRequest {
    hostSettings: HostSettings;
}

export interface GetApiHostsettingsRequest {
    id: string;
}

/**
 * 
 */
export class HostSettingsApiApi extends runtime.BaseAPI {

    /**
     */
    async addHostSettingsRaw(requestParameters: AddHostSettingsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<HostSettings>> {
        if (requestParameters.hostSettings === null || requestParameters.hostSettings === undefined) {
            throw new runtime.RequiredError('hostSettings','Required parameter requestParameters.hostSettings was null or undefined when calling addHostSettings.');
        }

        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        headerParameters['Content-Type'] = 'application/json';

        const response = await this.request({
            path: `/api/hostsettings`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            body: HostSettingsToJSON(requestParameters.hostSettings),
        }, initOverrides);

        return new runtime.JSONApiResponse(response, (jsonValue) => HostSettingsFromJSON(jsonValue));
    }

    /**
     */
    async addHostSettings(requestParameters: AddHostSettingsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<HostSettings> {
        const response = await this.addHostSettingsRaw(requestParameters, initOverrides);
        return await response.value();
    }

    /**
     */
    async getAllHostsettingsRaw(initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<Array<HostSettings>>> {
        const queryParameters: any = {};

        const headerParameters: runtime.HTTPHeaders = {};

        const response = await this.request({
            path: `/api/hostsettings/all`,
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        }, initOverrides);

        return new runtime.JSONApiResponse(response, (jsonValue) => jsonValue.map(HostSettingsFromJSON));
    }

    /**
     */
    async getAllHostsettings(initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<Array<HostSettings>> {
        const response = await this.getAllHostsettingsRaw(initOverrides);
        return await response.value();
    }

    /**
     */
    async getApiHostsettingsRaw(requestParameters: GetApiHostsettingsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<runtime.ApiResponse<HostSettings>> {
        if (requestParameters.id === null || requestParameters.id === undefined) {
            throw new runtime.RequiredError('id','Required parameter requestParameters.id was null or undefined when calling getApiHostsettings.');
        }

        const queryParameters: any = {};

        if (requestParameters.id !== undefined) {
            queryParameters['id'] = requestParameters.id;
        }

        const headerParameters: runtime.HTTPHeaders = {};

        const response = await this.request({
            path: `/api/hostsettings`,
            method: 'GET',
            headers: headerParameters,
            query: queryParameters,
        }, initOverrides);

        return new runtime.JSONApiResponse(response, (jsonValue) => HostSettingsFromJSON(jsonValue));
    }

    /**
     */
    async getApiHostsettings(requestParameters: GetApiHostsettingsRequest, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<HostSettings> {
        const response = await this.getApiHostsettingsRaw(requestParameters, initOverrides);
        return await response.value();
    }

}
